// Begin Pointdev 2.0.3.0

#include "win-system/Environment.h"

#include "config-lib/RegistrySettingsManager.h"

#include "win-system/Registry.h"
#include "win-system/RegistryKey.h"

#include "AdditionalQueryInformation.h"

AdditionalQueryInformation::AdditionalQueryInformation(bool isService)
{
	m_bRunAsService = isService;
  
	try {
    m_regSA = new RegistrySecurityAttributes();
  } catch (...) {
  }

	m_rootKey = isService ? HKEY_LOCAL_MACHINE : HKEY_CURRENT_USER;
	
	m_sa = 0;
  if (isService && m_regSA != 0) {
    m_sa = m_regSA->getServiceSA();
  }

	// Default
	m_bDisplayPeerIP=true;
	m_strPeerNetBIOSName.setString(_T(""));
	m_strPeerUserName.setString(_T(""));
	m_strPeerInfoMessage.setString(_T(""));
}

bool AdditionalQueryInformation::load()
{
  bool loadResult = true;
	
  RegistrySettingsManager sm(m_rootKey, _T("Software\\TightVNC_Pointdev\\Server\\"), m_sa);

  bool boolVal;
  UINT uintVal;
	StringStorage storage;

  if (!sm.getBoolean(_T("DisplayClientIpAddress"), &boolVal)) {
    loadResult = false;
  } else {
    m_bDisplayPeerIP = boolVal;
  }
  if (!sm.getString(_T("ClientHostname"), &storage)) {
    loadResult = false;
  } else {
		m_strPeerNetBIOSName.setString(storage.getString());
  }
	if (!sm.getString(_T("ClientUserName"), &storage)) {
    loadResult = false;
  } else {
		m_strPeerUserName.setString(storage.getString());
  }
		  if (!sm.getString(_T("AuthClientMessage"), &storage)) {
    loadResult = false;
  } else {
		m_strPeerInfoMessage.setString(storage.getString());
  }

  return loadResult;
}

bool AdditionalQueryInformation::getDisplayPeerIP()
{
	return m_bDisplayPeerIP;
}

StringStorage AdditionalQueryInformation::getPeerNetBIOSName()
{
		return m_strPeerNetBIOSName;
}

StringStorage AdditionalQueryInformation::getPeeruserName()
{
		return m_strPeerUserName;
}

StringStorage AdditionalQueryInformation::getPeerInfoMessage()
{
		return m_strPeerInfoMessage;
}

// Reset/delete concerned registry keys
bool AdditionalQueryInformation::resetKeys()
{
	bool bRet = false;
	
	RegistrySettingsManager sm(m_rootKey, _T("Software\\TightVNC_Pointdev\\Server\\"), m_sa);

	sm.deleteKey(_T("DisplayClientIpAddress"));
	sm.deleteKey(_T("ClientHostname"));
	sm.deleteKey(_T("ClientUserName"));
	sm.deleteKey(_T("AuthClientMessage"));

	return bRet;
}

// End